﻿package 
{
	import flash.display.DisplayObjectContainer;
	import flash.display.Sprite;
	import flash.events.Event;
	import flash.events.MouseEvent;	
	import flash.geom.ColorTransform;
	/**
	* ...
	* @author DefaultUser (Tools -> Custom Arguments...)
	*/
	public class Ripple extends Sprite 
	{
		private var container:DisplayObjectContainer;
		
		public function Ripple(theContainer:DisplayObjectContainer)
		{
			container = theContainer;
			container.stage.addEventListener(MouseEvent.CLICK, makeRipple);
		}
		
		private function makeRipple(event:MouseEvent):void
		{
			for (var i:uint = 1; i <= 4; i++)
			{
				var rippleSprite:Sprite = makeSprite();
				
				drawRing(rippleSprite);
			}
		}
		
		private function makeSprite():Sprite
		{
			var sp:Sprite = new Sprite();
			container.addChild(sp);
			sp.x = container.stage.mouseX;
			sp.y = container.stage.mouseY;
			
			sp.addEventListener(Event.ENTER_FRAME, onEnterFrame);
			return sp;
		}
		
		private function drawRing(sp:Sprite):void
		{
			var thickness:uint = 1;
			var color:uint = Math.random() * 0x666666;
			var alpha:Number = 1.0;
			var pixelHinting:Boolean = false;
			var scaleMode:String = "none";
			var cr:Number = 1 + Math.random() * 2;
			
			sp.graphics.lineStyle(thickness, color, alpha, pixelHinting, scaleMode);
			sp.graphics.drawCircle(0, 0, cr);
			//sp.transform.colorTransform = new ColorTransform(1, 0, 0, 1, 0, 0, 0, 0);
		}
		
		private function onEnterFrame(event:Event):void
		{
			var sp:Sprite = event.target as Sprite;
			
			if (sp.alpha > 0)
			{
				sp.scaleX += 5;
				sp.scaleY += 5;
				sp.alpha -= 0.05;
			}
			else
			{
				sp.graphics.clear();
				sp.removeEventListener(Event.ENTER_FRAME, onEnterFrame);
				container.removeChild(sp);
				sp = null;
			}
		}
	}
}